// File RTCG1D.cs --- first runtime code generation experiment
// sestoft@dina.kvl.dk * 2002, 2005-04-12

using System;
using System.Reflection;
using System.Reflection.Emit;

class RTCG1 {
  public static void Main(String [] args) {
    // Build: public static void MyMethod() { ... }
    DynamicMethod methodBuilder =
      new DynamicMethod("MyMethod", 
                        typeof(void),
                        new Type[] { },
                        typeof(String).Module);
    // Obtain an IL generator to build the method body
    ILGenerator ilg = methodBuilder.GetILGenerator();
    ilg.EmitWriteLine("MyClass.MyMethod() was called");
    ilg.Emit(OpCodes.Ret);  
    methodBuilder.Invoke(null, new object[] {});
  }
}
