// File RTCG2G.cs --- generating and calling a method with argument and result
// sestoft@dina.kvl.dk * 2005-10-16

using System;
using System.Reflection.Emit;
using Rtcg;

class RTCG2G {
  public static void Main(String [] args) {
    IFun<double,double> mm = 
      RTCG.RtcgFun<double,double>
      (delegate(ILGenerator ilg) {
	ilg.EmitWriteLine("Generated method was called");
	ilg.Emit(OpCodes.Ldarg_1);
	ilg.Emit(OpCodes.Ldc_R8, 2.1);
	ilg.Emit(OpCodes.Add);
	ilg.Emit(OpCodes.Ret);  
      });
    double res = mm.Invoke(5);
    Console.WriteLine(res);
  }
}
